#include <bits/stdc++.h>
using namespace std;

int main() {
    #define ll long long

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    //cout.tie(NULL);
    
    int m = 7 * 1e5;

    int t;
    cin >> t;


    ll n=0,a[m],b[m],c[m],res=0,am[2*m];
    for(int T = 0; T < t; T++)
    {
        cin >> n;
        res = 0;
        for(int i = 0; i < n; i++)
        {
            cin >> a[i] >> b[i] >> c[i];
            am[a[i]-1] += c[i];
            am[b[i]-1] += c[i];
        }


        //Треба оптимізувати пошук трьох типів хлопців, у кожних 2 з яких є спільна дівчинка, що подобається їм обом. Це повідомлення для апеляції
        for(int i = 0; i < n-2; i++)
        {
            for(int j = i+1; j < n-1; j++)
            {
                for(int k = j+1; k < n; k++)
                {
                    if(a[i] == a[j] or a[i] == b[j] or b[i] == a[j] or b[i] == b[j])
                    {
                        if(a[j] == a[k] or a[j] == b[k] or b[j] == a[k] or b[j] == b[k])
                        {
                            if(a[i] == a[k] or a[i] == b[k] or b[i] == a[k] or b[i] == b[k])
                            {
                                res = max(res,c[i]+c[j]+c[k]);
                            }
                        }
                    }
                }
            }
        }



        for(int i = 0; i < 2*n; i++)
        {
            res = max(res,am[i]);
            am[i] = 0;
        }

        cout << res << "\n";
    }
}